      program magmain
*
*==================================================================
*     x is beam direction
*     y is horzontal ( saleve to jura )
*     z is vertical  ( down to up )
*
*     units in meter
*                                         Gerd
*==================================================================
*
      COMMON/MAGNT1/ XMAGT1,XLMAG1,YLMAG1,ZLMAG1,YTMAG1,ZTMAG1,
     1               XXFSM1,YYFSM1,ZZFSM1,CNFSM1,SNFSM1
*
* --- FSM          FSM GEOMETRICAL DESCRIPTION
*
      DATA           XMAGT1,XLMAG1,YLMAG1,ZLMAG1,YTMAG1,ZTMAG1,
     1               XXFSM1,YYFSM1,ZZFSM1,CNFSM1,SNFSM1
     2              /-0.00100,2.00000,1.00000,0.50000,1.50000,1.00000,
     3               -0.00100,-0.07510,0.00000,0.99920,0.00080/
*
      INTEGER      CHBEM1
*
      CHBEM1 = 1
      XFMAG1 = 5.
*
      open ( unit=21,status='old',file='magb4000.fieldmap' )
C
C *** CALCULATION OF MAGNETIC FIELD COMPONENTS
C
C *** CHANGE TO MAGNET (FSM) COORDINATE SYSTEM
C
      BX=0.0
      BY=0.0
      BZ=0.0
1     write(6,*) 'enter x,y,z [m]: '
      read(5,*) x,y,z
C
C *** CHECK ON INPUT POSITION
C
      IF(ABS(X).GT.XFMAG1.OR.ABS(Y).GT.1.0.OR.ABS(Z).GT.0.5) then
        write(6,*) 'choose reasonable value for x,y,z!'
        goto 1
        endif
C
      XX=(X-XXFSM1)*CNFSM1+(Y-YYFSM1)*SNFSM1
      YY=(Y-YYFSM1)*CNFSM1-(X-XXFSM1)*SNFSM1
      ZZ=Z
*
C
C *** LONG MAGFIELD ROUTINE
C
      CALL MAGB(XX,YY,ZZ,BX,BY,BZ,IERR)
C
C *** SCALE FIELD BY BEAM CHARGE TO KEEP BENDING IN RIGHT DIRECTION
C
      BXX=-BX*CHBEM1
      BYY=-BY*CHBEM1
      BZ =-BZ*CHBEM1
C
C *** NOW ROTATE BACK INTO LAB SYSTEM
C
      BX=BXX*CNFSM1-BYY*SNFSM1
      BY=BYY*CNFSM1+BXX*SNFSM1
C
      write(6,*) "abc"
      write(6,'(''field for x,y,z'')')
      write(6,'(3F12.3,/,3F12.3)') x,y,z,bx,by,bz
      write(6,*)
      goto 1
      END
*CMZ : 20.00/05 17/05/94  11.09.16  by  Jens Vogt
*CMZ : 20.00/03 12/04/94  16.03.47  by  Jens Vogt
*CMZ : 19.01/11 05/04/93  12.20.17  by  Christian Cavata
*CMZ : 18.00/00 28/02/92  12.04.48  by  Ian Bird
*-- Author :
C========================================================================
      SUBROUTINE MAGB(Y1,X1,Z1,BY,BX,BZ,IFLAG)
C========================================================================
C
C *** ALL INPUT/OUTPUT VARIABLES IN THE MAGNET COORDINATE SYSTEM
C *** THE TRANSLATION TO EMC IS MADE IN THE CALLING SEQUENCE
C *** INPUT/OUTPUT VARIABLE UNITS ARE METRES,GAUSS
C *** INTERNAL UNITS ARE CMS,GAUSS
C *** FOR A CALL ....   CALL MAGB(X,Y,Z,BX,BY,BZ)
C *** NOTE THAT X (MAGNET) = Y (EMC)
C *** NOTE THAT Y (MAGNET) = X (EMC)
C *** NOTE THAT Z (MAGNET) = -Z (EMC)
C
C +++
C +++ FOR DETAILS OF METHOD SEE 'THE ANALYSIS OF THE MAGNETIC FIELD OF
C +++ THE FORWARD SPECTROMETER MAGNET ' C.H.BEST,A.M.OSBORNE EMC/78/26
C +++ OR (SHORT WRITE UP) 'THE REPRESNTATION OF THE MAGNETIC FIELD OF
C +++ THE FORWARD SPECTROMETER ' BY SAME AUTHORS. THIS IS A SUBSET OF
C +++ EMC/78/26.
C +++
*KEEP,FSMGB1.
      COMMON/FSMAG1/FSMAX1(1770),FSMAY1(2360),FSMAZ1(3540),FSMBX1(472)
     1,FSMBY1(300),FSMCX1(84),FSMCY1(126),FSMCZ1(168),FSMDX1(312),
     2 FSMDY1(390),FSMDZ1(468),FSMA01,FSMA11,IFSMC1
*
*KEND.
      DIMENSION BXX(3,3),BYY(3,3),BZZ(3,3),BXXX(3),BYYY(3),BZZZ(3),
     +          CY1(10,30),TITLE(18)
      DOUBLE PRECISION Z,Z2,Z3,Z4,Z5,Z6,Z7,Z8,Z9,Z10
      EQUIVALENCE(BXXX1,BXXX(1)),(BYYY1,BYYY(1)),(BZZZ1,BZZZ(1)),
     + (BXXX2,BXXX(2)),(BYYY2,BYYY(2)),(BZZZ2,BZZZ(2)),
     + (BXXX3,BXXX(3)),(BYYY3,BYYY(3)),(BZZZ3,BZZZ(3))
      EQUIVALENCE(CY1(1,1),FSMBY1(1))
      SAVE IRFSM1
      DATA IRFSM1/0/
C
      IF(IRFSM1) 10,10,20
C
C *** READ IN COEFFTS
C
   10 IRFSM1=1
      LUN=21
      NPRIN6=6
      READ(LUN,10000) IFSMC1,TITLE
      WRITE(NPRIN6, 10100)IFSMC1,TITLE
      READ(LUN,10200) FSMA01,FSMA11
      READ(LUN,10200) FSMAX1
      READ(LUN,10200) FSMBX1
      READ(LUN,10200) FSMAY1
      READ(LUN,10200) FSMBY1
      READ(LUN,10200) FSMAZ1
      READ(LUN,10200) FSMCX1
      READ(LUN,10200) FSMCY1
      READ(LUN,10200) FSMCZ1
      READ(LUN,10200) FSMDX1
      READ(LUN,10200) FSMDY1
      READ(LUN,10200) FSMDZ1
10000 FORMAT(I8,18A4)
10100 FORMAT(1H0,7X,42HFORWARD SPECTROMETER MAGNETIC FIELD OPTION /
     + 8X,42(1H-)//1X,I8,18A4)
10200 FORMAT(5E16.7)
   20 CONTINUE
C
C *** CHANGE TO CENTIMETRES
C
      XX=X1*100.0
      YY=Y1*100.0
      ZP=Z1*100.0
C
C *** CHANGE Z FOR EMC/MAGNET DIFFERENCE
C
      ZZ=-ZP
C
C *** FIELD CURRENT SIGN
C
      FC=-1.0
      X=ABS(XX)
      Y=ABS(YY)
      Z=ABS(ZZ)
C
C *** PROTECT AGAINST UNDERFLOW (GENUINE ONES !!)
C
      IF(Z.LT.1.0E-5) Z=0.0
C
      IFLAG=0
      BX=0.0
      BY=0.0
      BZ=0.0
C
C *** HIT THE MAGNET ??
C
      IF(Y-200.0) 30 ,30 ,40
   30 IF(X.GT.101.5) GO TO 310
      IF(Y.LT.120.0.AND.Z.GT.50.0) GO TO 310
      IF(Y.GE.120.0.AND.Z.GT.52.0) GO TO 310
C
C *** IN MAGNETIC FIELD REGION ??
C
   40 IF(Y.GT.340.0) GO TO 320
      IF(Z.GT.69.0) GO TO 320
      IF(X.GT.144.0) GO TO 320
C
C *** COMPONENT SIGNS
C
      XS=SIGN(1.0,XX)
      ZS=SIGN(1.0,ZZ)
C
C *** IN MAIN BOX ??
C
      IF(X.GT.101.5.AND.Y.GT.200.) GO TO 250
      IF(Z.GT.50.0.AND.Y.GT.200.0) GO TO 250
      IF(Y.LT.222.0.AND.Z.LE.52.0) GO TO 50
C
C *** MUST BE FRINGE FIELD REGION
C
      GO TO 250
C
C *** MAIN FIELD - FIRST WORK OUT Y SHIFT AS FUNCTION OF X
C
C
C *** SET EXTRAPOLATION FLAG IF NECESSARY
C
   50 IF(X.GT.96.0) IFLAG=1
C
C *** LIMIT X IF NECESSARY
C
      IF(X.GT.96.0) X=96.0
C
C *** LIMIT Z IF NECESSARY
C
      IF(Y.GT.120.0.AND.Z.GT.50.0) GO TO 60
      IF(Y.LE.120.0.AND.Z.GT.48.0) GO TO 70
      GO TO 80
   60 IFLAG=1
      Z=50.0
      GO TO 80
   70 IFLAG=1
      Z=48.0
   80 CONTINUE
      DELY=FSMA01+FSMA11*(16.0-X/6.0)**2
      Y=-ABS(YY+DELY)
C
C *** Y COMPONENT SIGN
C
      YS=-SIGN(1.0,YY+DELY)
C
C *** WORK OUT X RANGE AND ARRAY NUMBER
C
      IF(X-36.) 90,90,100
   90 NX1=-1
      DX=18.
      XR=X
      GO TO 130
  100 IF(X-72.) 110,110,120
  110 XR=X-36.0
      NX1=XR/12.0
      IF(NX1.LT.1) NX1=1
      IF(NX1.GT.2) NX1=2
      DX=12.0
      XR=XR-(NX1-1)*12.0
      GO TO 130
  120 XR=X-54.0
      NX1=XR/6.0
      IF(NX1.LT.4) NX1=4
      IF(NX1.GT.6) NX1=6
      DX=6.0
      XR=XR-(NX1-1)*6.0
C
C *** WORK OUT Y RANGE AND ARRAY NUMBER
C
  130 IF(Y+212.) 140,140,150
  140 YR=Y+224.0
      NY1=YR/6.0
      IF(NY1.LT.-1) NY1=-1
      IF(NY1.GT.1) NY1=1
      DY=6.0
      YR=YR-(NY1-1)*6.0
      GO TO 200
  150 IF(Y+80.) 160,160,170
  160 YR=Y+218.0
      NY1=YR/3.0
      IF(NY1.LT.3) NY1=3
      IF(NY1.GT.45) NY1=45
      DY=3.0
      YR=YR-(NY1-1)*3.0
      GO TO 200
  170 IF(Y+50.) 180,180,190
  180 YR=Y+356.0
      NY1=YR/6.0
      IF(NY1.LT.47) NY1=47
      IF(NY1.GT.50) NY1=50
      DY=6.0
      YR=YR-(NY1-1)*6.0
      GO TO 200
  190 YR=Y+662.0
      NY1=YR/12.0
      IF(NY1.LT.52) NY1=52
      IF(NY1.GT.55) NY1=55
      DY=12.0
      YR=YR-(NY1-1)*12.0
C
C *** FORM POWERS OF Z FOR LOCAL Z FITS
C
  200 Z2=Z*Z
      Z3=Z2*Z
      Z4=Z2*Z2
      Z5=Z4*Z
      Z6=Z5*Z
      Z7=Z6*Z
      Z8=Z7*Z
      Z9=Z8*Z
      Z10=Z9*Z
      MX=NY1*30+NX1*3
      MX1=NY1*8+2*NX1-12
      LY=NY1+1
      DO 240 IY=1,3
         LY=LY+1
         MX=MX+30
         MX1=MX1+8
         JX=MX
         JX1=MX1
         LX=NX1+1
         DO 230 IX=1,3
            LX=LX+1
            JX=JX+3
            JX1=JX1+2
            JY=JX+JX/3
            JZ=JX+JX
            VX=FSMAX1(JX+1)*Z+FSMAX1(JX+2)*Z3+FSMAX1(JX+3)*Z5
            VY=FSMAY1(JY+1)*Z+FSMAY1(JY+2)*Z3+FSMAY1(JY+3)*Z5+
     +      FSMAY1(JY+ 4)*Z7
            BZZ(IY,IX)=FSMAZ1(JZ+1)+FSMAZ1(JZ+2)*Z2+FSMAZ1(JZ+3)*Z4+
     +      FSMAZ1(JZ+ 4)*Z6+FSMAZ1(JZ+5)*Z8+FSMAZ1(JZ+6)*Z10
            IF(LX.LE.6) GO TO 210
C
C *** EXTRA X TERMS
C
            VX=VX+FSMBX1(JX1+1)*Z7+FSMBX1(JX1+2)*Z9
  210       IF(LY.LE.15.OR.LY.GE.46) GO TO 220
C
C *** EXTRA Y TERMS
C
            VY=VY+CY1(LX,LY-15)*Z9
  220       BXX(IY,IX)=VX
            BYY(IY,IX)=VY
  230    CONTINUE
  240 CONTINUE
      GO TO 290
C
C *** FRINGE FIELD EVALUATION
C
C
C *** Y COMPONENT SIGN
C
  250 YS=-SIGN(1.0,YY)
C
C *** MAKE NECESSARY Y SHIFT
C
      IF(YY.GT.0.0) Y=-YY
      IF(YY.LT.0.0) Y=YY+2.0*(FSMA01+FSMA11*(16.0-X/6.0)**2)
C
C
C *** ADJUST Y TO NEAREST FRINGE FIELD MEASUREMENT IF NECESSARY
C
      IF(Y.GE.-220.0) IFLAG=1
      IF(Y.GT.-220.0) Y=-220.0
C
C *** FORM LOCAL Z POLYNOMIALS
C
      Z2=Z*Z
      Z3=Z2*Z
      Z4=Z2*Z2
      Z5=Z3*Z2
      Z6=Z4*Z2
      IF(Y.GT.-250.0) GO TO 270
      NX1=X/24.0-2.0
      IF(NX1.LT.-1) NX1=-1
      IF(NX1.GT.3) NX1=3
      YR=Y+340.0
      NY1=YR/18.0-2.0
      IF(NY1.LT.-1) NY1=-1
      IF(NY1.GT.2) NY1=2
      MX=14*NY1+2*NX1
      DO 260 IY=1,3
         MX=MX+14
         JX=MX
         DO 260 IX=1,3
            JX=JX+2
            JY=JX+JX/2
            JZ=JX+JX
            BXX(IY,IX)=FSMCX1(JX+1)*Z+FSMCX1(JX+2)*Z3
            BYY(IY,IX)=FSMCY1(JY+1)*Z+FSMCY1(JY+2)*Z3+FSMCY1(JY+3)*Z5
            BZZ(IY,IX)=FSMCZ1(JZ+1)+FSMCZ1(JZ+2)*Z2+FSMCZ1(JZ+3)*Z4+
     +      FSMCZ1(JZ+ 4)*Z6
  260 CONTINUE
      DX=24.0
      DY=18.0
      YR=YR-(NY1+1)*18.0
      XR=X-(NX1+1)*24.0
      GO TO 290
  270 NX1=X/12.0-2.0
      IF(NX1.LT.-1) NX1=-1
      IF(NX1.GT.9) NX1=9
      DX=12.0
      YR=Y+250.0
      NY1=YR/6.0-2.0
      IF(NY1.LT.-1) NY1=-1
      IF(NY1.GT.2) NY1=2
      DY=6.0
      Z7=Z5*Z2
      Z8=Z4*Z4
      Z9=Z7*Z2
      Z10=Z9*Z
      MX=NY1*52+NX1*4
      DO 280 IY=1,3
         MX=MX+52
         JX=MX
         DO 280 IX=1,3
            JX=JX+4
            JY=JX+JX/4
            JZ=JX+JX/2
            BXX(IY,IX)=FSMDX1(JX+1)*Z+FSMDX1(JX+2)*Z3+FSMDX1(JX+3)*Z5+
     +      FSMDX1( JX+4)*Z7
            BYY(IY,IX)=FSMDY1(JY+1)*Z+FSMDY1(JY+2)*Z3+FSMDY1(JY+3)*Z5+
     +      FSMDY1( JY+4)*Z7+FSMDY1(JY+5)*Z9
            BZZ(IY,IX)=FSMDZ1(JZ+1)+FSMDZ1(JZ+2)*Z2+FSMDZ1(JZ+3)*Z4+
     +      FSMDZ1(JZ +4)*Z6+FSMDZ1(JZ+5)*Z8+FSMDZ1(JZ+6)*Z10
  280 CONTINUE
      YR=YR-(NY1+1)*6.0
      XR=X-(NX1+1)*12.0
C
C *** DO Y INTERPOLATION
C
  290 YR=YR/DY
      DO 300 IX=1,3
         A=(BXX(3,IX)+BXX(1,IX)-2.0*BXX(2,IX))/2.0
         B=BXX(2,IX)-BXX(1,IX)-A
         BXXX(IX)=(A*YR+B)*YR+BXX(1,IX)
         A=(BYY(3,IX)+BYY(1,IX)-2.0*BYY(2,IX))/2.0
         B=BYY(2,IX)-BYY(1,IX)-A
         BYYY(IX)=(A*YR+B)*YR+BYY(1,IX)
         A=(BZZ(3,IX)+BZZ(1,IX)-2.0*BZZ(2,IX))/2.0
         B=BZZ(2,IX)-BZZ(1,IX)-A
         BZZZ(IX)=(A*YR+B)*YR+BZZ(1,IX)
  300 CONTINUE
C
C *** DO X INTERPOLATION
C
      XR=XR/DX
      A=(BXXX3+BXXX1-2.0*BXXX2)/2.0
      B=BXXX2-BXXX1-A
      VX=(A*XR+B)*XR+BXXX1
      A=(BYYY3+BYYY1-2.0*BYYY2)/2.0
      B=BYYY2-BYYY1-A
      VY=(A*XR+B)*XR+BYYY1
      A=(BZZZ3+BZZZ1-2.0*BZZZ2)/2.0
      B=BZZZ2-BZZZ1-A
      VZ=(A*XR+B)*XR+BZZZ1
C ***
C *** BX,BY,BZ IN EMC COORDINATE SYSTEM
C ***
      BX=VX*XS*ZS*FC
      BY=VY*YS*ZS*FC
      BZ=-VZ*FC
      RETURN
C
C *** HIT MAGNET
C
  310 IFLAG=2
      RETURN
C
C *** OUTSIDE MEASURED REGION
C
  320 IFLAG=3
      RETURN
      END
